∇jgirl, talk
repl ∆≣ 'jrepl/jrepl'


assign_repl_honor = ➮ - repl ctx _jgirl _talk {
	repl.commands.helo = helo
	repl.commands.act = act
	repl.commands.actors = actors
	repl.commands['new-actor'] = new_actor
	repl.commands.reset = reset
	repl.commands.prime = prime
	repl.commands.label = label
	repl.commands['labels-on'] = labels_on
	repl.commands.show = show
	repl.commands['usable-by'] = usable_by
	repl.commands['users-of'] = users_of
	repl.commands.labeled = labeled
	repl.commands.give = give
	repl.commands['link-find'] = link_find
	repl.commands.check = check
	repl.commands.share = share
	repl.commands.allow = allow
	repl.commands.ask = ask
	repl.commands.revoke = revoke
	repl.commands['ballots-on'] = ballots_on
	repl.commands['new-row'] = new_row
	repl.commands['new-elect'] = new_elect
	repl.commands.find = find
	jgirl = _jgirl
	talk = _talk
}

➮ helo ctx inp f {
	ロ 'helo!'
	f()
}

//$ -➮-prime- == 13
➮ prime ctx inp f {
	pak ∆ repl.parse(inp, [@name comment], [], f)
	❰!pak❱ $
	pak.id = 'prime'
	talk(ctx.socket, pak, ➮ - ctx pak re {
		❰pak.ok❱
			ロ 'ok'
		◇
			ロ pak.msg
			⁋
		f()
	})
}

//$ help-prime --- 7
repl.help.prime = '''
PRIMES.
Prime is something that can be labeled or can label as well.
When a prime is labeled it is called a document.
When a prime labels something it is called a label.
Netiety is built arount the concept of a prime, everything here is a prime: labels, docs, votes, rows, elects, actors. In other words, everything can be labeled or be used as a label.
But not everybody can use any prime, only those who created them or those who was given the access rights.


See also:
help actors
help right
'''

//$ -➮-actors- == 13
➮ actors ctx inp f {
	pak ∆ repl.parse(inp, [], [], f)
	❰!pak❱ $
	pak.id = 'actors'
	talk(ctx.socket, pak, ➮ - ctx pak re {
		❰pak.ok❱
			ロ pak.actors
		◇
			ロ pak.msg
			⁋
		f()
	})
}

//$ help-actors --- 7
repl.help.actors = '''
ACTORS.

In Netiety there is no concept of a login name, instead to enter Netiety you use a secret key alone and enter anonymously, after you enter, you must create an actor with the "new-actor" command and use it to do things on Netiety publicly. Your actor name must be unique.

You can have as many actors as you want. You switch between them with the "act" command.

The actor name must be at least 4 characters long.

See also:
help enter
help act  --  select current actor.
help new-actor  --  create new actor.

'''

//$ -➮-act- == 13
➮ act ctx inp f {
	pak ∆ repl.parse(inp, [], [@actor], f)
	❰!pak❱ $
	pak.id = 'act'
	talk(ctx.socket, pak, ➮ - ctx msg re {
		❰msg.ok❱
			❰msg.actor❱
				ロ 'You are now 'msg.actor'.'
			◇
				ロ 'Actor is not selected.'
				⁋
			❰msg.actors❱
				❰msg.actors↥ ≟ 0❱
					ロ 'see "help actors".'
					⁋
				ロ 'Available: 'msg.actors ⫴ ', '
				⁋
		◇
			ロ 'Error: 'msg.msg
			⁋
		f()
	})
}

//$ -➮-act- --- 7
repl.help.act = '''
ACT.
Act as one of your actors. Choose one of your actors to be currently used for your actions.

^ act actor=actor-id

Display current actor if no arguments were provided.
See "help actors" to know more.
'''

//$ -➮-new--actor- == 13
➮ new_actor ctx inp f {
	pak ∆ repl.parse(inp, [@name comment], [], f)
	❰!pak❱ $
	pak.id = 'new-actor'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		ロ bak.msg
		f()
	})
}

//$ -help-new--actor- --- 7
repl.help['new-actor'] = '''
NEW ACTOR.
Create new actor. 

^ new-actor actor=actor-id

Actor ID must be at least 4 characters long.
See "help actors" to know more.
'''

//$ -➮-show- == 10
➮ show ctx inp f {
	pak ∆ repl.parse(inp, [], [], f)
	❰!pak❱ $
	pak.id = 'show'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			i ► bak.data
				ロ i⁰ ': ' i¹
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -show- --- 7
repl.help.show = '''
SHOW PRIME.
Display the prime data.

See "help primes" to know more.
'''

//$ -➮-usable-by- == 13
➮ usable_by ctx inp f {
	// TODO: change "usable-by" to "usable" or "usable by"
	pak ∆ repl.parse(inp, [@actor], [], f)
	❰!pak❱ $
	pak.id = 'usable-by'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data ❄() ⫴ ' '
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -usable-by- --- 7
repl.help['usable-by'] = '''
SHOW PRIMES THAT THE ACTOR CAN USE.
	usable-by <actor> [right]

See "help right", "help actors".

'''
//$ -➮-label- == 13
➮ label ctx inp f {
	pak ∆ repl.parse(inp, [@label doc], [], f)
	❰!pak❱ $
	pak.id = 'label'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ 'ok'
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -label- --- 7
repl.help.label = '''
LABEL PRIME WITH A PRIME.

label <label> <doc>
'''

//$ -➮-share- == 13
➮ share ctx inp f {
	pak ∆ repl.parse(inp, [@label], [], f)
	❰!pak❱ $
	pak.id = 'share'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ 'ok'
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -share- --- 7
repl.help.share = '''
SHARE THE LABEL.
Make your label public with voting. Let others to ask you or the group of people to vote to set your label. This command does not configure the voting and proposing rights, this is only the first step, see "allow", "ask", "vote".

share <label>

See "help allow", "help ask", "help vote" to know more.
'''

//$ -➮-labeled- == 10
➮ labeled ctx inp f js {
	pak ∆ repl.parse(inp, [@prime], [], f)
	❰!pak❱ $
	pak.id = 'labeled'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			❰js❱
				s ∆ js.re('$', ꗌbak.data)
				ロ eval('s='+s)
			◇
				ロ bak.data ⫴ ' '
				⁋
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -labeled- --- 7
repl.help.labeled = '''
SHOW PRIMES LABELED BY A GIVEN PRIME.
	labeled <prime>

See "help primes" to know more.
'''

//$ -➮-labels-on- == 10
➮ labels_on ctx inp f js {
	pak ∆ repl.parse(inp, [@prime], [], f)
	❰!pak❱ $
	pak.id = 'labels-on'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰js❱
			s ∆ js.re('$', ꗌbak.data)
			ロ eval('s='+s)
		◇
			ロ bak.data ⫴ ' '
			⁋
		f()
	})
}

//$ -labels-on- --- 7
repl.help['labels-on'] = '''
SHOW LABELED ON THE GIVEN PRIME.
	labels-on <prime>

See "help primes" to know more.
'''


//$ -➮-users-of- == 10
➮ users_of ctx inp f {
	pak ∆ repl.parse(inp, [@prime], [@right], f)
	❰!pak❱ $
	pak.id = 'users-of'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data ⫴ ' '
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -users-of- --- 7
repl.help['users-of'] = '''
SHOW ACTORS WHO CAN USE THIS PRIME.
	users-of <prime> [right]

See "help right", "help actors".

'''
//$ -right- --- 7
repl.help.right = repl.help.rights = '''
RIGHT.

There are various kinds of actions the actor can do with the prime, most basic are use, share, give. The rights are personal, and these three basic rights are given to the creator of the prime by default and can be given out with the "give" or "share" commands.

use - "Use" here means the prime can be used as a label. 
give - If you have the share right on the prime you can let others use it.
share - Enables you to make the label votable.

See also:
	help give
	help share

'''

//$ -➮-give- == 10
➮ give ctx inp f {
	pak ∆ repl.parse(inp, [@prime func actor], [], f)
	❰!pak❱ $
	pak.actors = []
	❰pak.args❱ pak.actors = pak.args
	pak.actors ⬋ pak.actor
	⏀ pak.args
	pak.id = 'give'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ 'Server: 'bak.msg
			⁋
		f()
	})
}

//$ -give- --- 7
repl.help['give'] = '''
GIVE THE OTHERS THE RIGHT TO USE YOUR PRIME AS A LABEL DIRECTLY.
	give <prime> <func> <actor> [actor]...

Example:
	give alice.like allow cat

See "help right", "help actors", "help func".

'''

//$ -➮-check- == 10
➮ check ctx inp f {
	pak ∆ repl.parse(inp, [@right actor prime], [], f)
	❰!pak❱ $
	pak.id = 'check'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ 'Server: 'bak.msg
			⁋
		f()
	})
}

//$ -check- --- 7
repl.help['check'] = '''
CHECK RIGHTS.
	check <right> <actor> <prime>

Example:
	check label hare alice.like

See "help right".

'''

//$ -➮-allow- == 10
➮ allow ctx inp f {
	pak ∆ repl.parse(inp, [@right prime method actor], [], f)
	❰!pak❱ $
	pak.id = 'allow'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ 'Server: 'bak.msg
			⁋
		f()
	})
}

//$ -allow- --- 7
repl.help.allow = '''
ALLOW VOTE OR ASK.
	allow <right> <prime> <method> <actor>

Example:
	allow vote white.law allow() alice

To reverse the 'allow' use 'revoke'.

See "help right", "help revoke".

'''

//$ -➮-ask- == 10
➮ ask ctx inp f {
	pak ∆ repl.parse(inp, [@label doc msg], [], f)
	❰!pak❱ $
	pak.id = 'ask'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -ask- --- 7
repl.help.ask = '''
ASK TO LABEL WITH A SHARED LABEL.
	ask <label> <doc> <msg>

<msg> is any text you want that will help others to understand why you want this to happen.

Example:
	^ act white
	^ share white.law
	^ act alice
	^ ask white.law white.constitution I-like-the-idea!

See "help voting".

'''

//$ -➮-revoke- == 10
➮ revoke ctx inp f {
	pak ∆ repl.parse(inp, [@right prime], [], f)
	❰!pak❱ $
	pak.id = 'revoke'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -revoke- --- 7
repl.help.revoke = '''
REVOKE YOUR RIGHT FOR A PRIME.
	revoke <right> <prime>

<right> is any right that you have on this prime, i.e. 'vote', 'ask', 'share'.

After you remove your 'share' right, you loose the control on the tag from now on.

See "help voting".

'''

//$ -➮-new-row- == 10
➮ new_row ctx inp f {
	pak ∆ repl.parse(inp, [@name comment list], [], f)
	❰!pak❱ $
	pak.list = [pak.list] ꗚ pak.args
	⏀ pak.args
	pak.id = 'new-row'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -new-row- --- 7
repl.help['new-row'] = '''
CREATE NEW ROW.
	new-row <name> <comment> <list of items...>

A row is a set of primes that contradict each other. For instance you can label something 'good' or 'bad', but not 'good' and 'bad' together. Primes in a row are also called 'members'. If you label something with one member, then with another, the first label will be atomatically removed.

Example:
	new-row style My-opinion good bad ugly
	
	The above will create the row named 'style', and add newly created primes 'good', 'bad' and 'ugly' into it. All primes must not exist before this call, and must not be duplicate. If, for instance, you already have created the prime 'good' before, then 'new-row' will fail.

See "help voting".

'''

//$ -➮-new-elect- == 10
➮ new_elect ctx inp f {
	pak ∆ repl.parse(inp, [@name comment], [], f)
	❰!pak❱ $
	pak.list = [pak.list] ꗚ pak.args
	⏀ pak.args
	pak.id = 'new-elect'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -new-elect- --- 7
repl.help['new-elect'] = '''
CREATE NEW ELECT.
	new-elect <name>

An elect is a label that can only label one thing. If you want to use it to label something else, it will be first removed from the first thing and then set on another thing. It is useful for example when you want a label named 'president' so only one person at a time can be labeled 'president'. This is exactly what elect is.

Example:
	new-elect group-president A-president-of-our-group.
	
'''

//$ -➮-ballots--on- == 10
➮ ballots_on ctx inp f {
	pak ∆ repl.parse(inp, [@prime], [], f)
	❰!pak❱ $
	pak.id = 'ballots-on'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			ロ bak.data
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -ballots--on- --- 7
repl.help['ballots-on'] = '''
SHOW BALLOTS ON THE QUESTION.
	ballots-on <question>

When voting is happening, you can see all 'yes' and 'no' ballots that are currently set on the given question. 

See "help voting".

'''
//$ -voting- --- 7
repl.help.voting = '''
VOTING IN NETIETY.

Before voting can happen, someone must share their label. See "help share".

Voting is initialized by <asking> some <label> to be put on some <doc>. See "help ask".

As a result, the <question> is created. Question is a temporary prime that exists only for this particular voting process. The format of a question prime name is "label@doc". For example you want to label the document "john.book1" with the label "library.good-book", then you issue a command:

	^ ask library.good-book john.book1 I-think-this-is-a-great-book!

Now the <question> "library.good-book@john.book1" is created and others can vote for it using the "label" command and their "yes" and "no" ballot vote primes like this:

	^ act Mary
	^ label library.good-book@john.book1 yes
	
	^ act Tom
	^ label library.good-book@john.book1 no

See "help share", "help allow", "help right".

'''

//$ -➮-find- == 13
➮ find ctx inp f js {
	pak ∆ repl.parse(inp, [@string], [], f)
	❰!pak❱ $
	pak.id = 'find'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			❰js❱
				s ∆ js.re('$', ꗌbak.data)
				s = eval('s='+s)
				ロ s
			◇
				ロ bak.data
				⁋
		◇
			ロ bak.msg
			⁋
		f()
	})
}

//$ -find- --- 7
repl.help.find = '''
FIND PRIME.
	find <string>

'''
//$ -➮-reset- %%% #00f

➮ reset ctx inp f {
	pak ∆ repl.parse(inp, [@password], [], f)
	❰!pak❱ $
	pak.id = 'reset'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		ロ bak.msg
		f()
	})
}

//$ -➮-link-find- %%% #00f
➮ link_find ctx inp f js {
	pak ∆ repl.parse(inp, [@secret], [], f)
	❰!pak❱ $
	pak.id = 'link-find'
	talk(ctx.socket, pak, ➮ - ctx bak re {
		❰bak.ok❱
			❰js❱
				s ∆ js.re('$', ꗌbak.data)
				s = eval('s='+s)
				ロ s
			◇
				ロ bak.data
				⁋
		◇
			ロ 'Server: 'bak.msg
			⁋
		f()
	})
}

